/**
* lcdisplay
* JavaScript LCD plugin using jQuery
* 19.05.2013 - Jaroslav Herber - By Solare Datensysteme GmbH
*
* Version: 1.0.0
*
*/

var LCDMode=
{
				 "OFF":              0,
				 "ON":               1,
				 "BLINK_NUMBER":     2,
				 "BLINK_NONUMBER":   3,
				 "ON0":         	 4,
				 "ON1":         	 5,
				 "ON2":         	 6,
				 "ON3":         	 7,
				 "ON4":         	 8,
				 "ON5":         	 9,
				 "RUNSTATE2":		 10,
				 "RUNSTATE3":		 11,
				 "LCD_BLINK_NUMBER_EI":		 12
};
			
var LCDState = [
	[LCDMode.OFF,  0, 0, 0, "t1", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t2", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t3", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t4", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t5", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t6", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t7", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "bat", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t8", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "gprs", null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "easy", null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t9", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "sig", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t10", 	null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "wifi", null, LCDMode.ON],
	[LCDMode.OFF,  0, 0, 0, "t11", 	null, LCDMode.ON]
];
	var LCDTimer=0;
	
	var TheDisplay;

	var LCD_newIDBlinkNumber=0;
	var LCD_idBlinkNumber=255;
	var LCD_blinkset=0;
	var LCD_cnt=0;
	var LCD_i=0;
	var LCD_j=0;
	var c_maxcount=10;
	
	// spssle
	//var scrolltext="HALLO CHRISTOPH LASS UNS EINE RAUCHEN     ";
	//var scrollpos=0;
	//var scrollcount=scrolltext.length-2;
	
	
	
	function getNextBlinkNumber(oldIDBlinkNumber, cnt)
	{
		var i;
		var BlinkCnt = 0;
		var BlinkArray = new Array(LCDState.length);
		var newIDBlinkNumber = 255;
		var old = false;

		for (i = 0; i < LCDState.length; i++)
		{
			if (LCDState[i][0] == LCDMode.BLINK_NUMBER || LCDState[i][0] == LCDMode.BLINK_NONUMBER || LCDState[i][0] == LCDMode.LCD_BLINK_NUMBER_EI)
			{
				BlinkArray[BlinkCnt] = i;
				BlinkCnt++;
				if (i == oldIDBlinkNumber)
					old = true;
			}
		}
		if (BlinkCnt == 0)
			newIDBlinkNumber = 255;
		else if (BlinkCnt == 1)
			newIDBlinkNumber = BlinkArray[0];
		else if (old == false || cnt > c_maxcount)
		{
			for (i = 0; i < BlinkCnt; i++)
			{
				if (BlinkArray[i] > oldIDBlinkNumber) // nchst grerer Wert gefunden
				{
					newIDBlinkNumber = BlinkArray[i];
					break;
				}
			}
			if (newIDBlinkNumber == 255) // Kein Code danach gefunden, also ersten verwenden
				newIDBlinkNumber = BlinkArray[0];
		}
		else
		{
			newIDBlinkNumber = oldIDBlinkNumber;
		}
		return newIDBlinkNumber;
	}

	function ManageLCD()
	{
		LCD_newIDBlinkNumber = getNextBlinkNumber(LCD_idBlinkNumber, LCD_cnt);
		if (LCD_idBlinkNumber != LCD_newIDBlinkNumber)
		{
			LCD_cnt = 0;
			LCD_blinkset = 0;
		}
		if (LCD_cnt > c_maxcount)
		{
			LCD_cnt = 0;
			LCD_blinkset = 0;
		}
		
		
		for(var oth=0;oth!=LCDState.length;oth++)
		{
			if(oth!=LCD_newIDBlinkNumber )
			{
				if(LCDState[oth][0]==LCDMode.ON || LCDState[oth][0]==LCDMode.BLINK_NONUMBER || LCDState[oth][0]==LCDMode.BLINK_NUMBER || LCDState[oth][0]==LCDMode.LCD_BLINK_NUMBER_EI)
				{
					TheDisplay.lcdisplay('setItem', LCDState[oth][4],  true);
				}
				else if(LCDState[oth][0]==LCDMode.OFF)
				{
					TheDisplay.lcdisplay('setItem', LCDState[oth][4], false);
				}
				else
				{
					TheDisplay.lcdisplay('setItem', LCDState[oth][4], LCDState[oth][0]);
				}
			}
		}

		if (LCD_newIDBlinkNumber == 255) // Kein aktueller Fehlercode eingetragen, deshalb drfen alle anderen Elemente blinken
		{
			TheDisplay.lcdisplay('setA', 'O');
			TheDisplay.lcdisplay('setB', 'K');
			
			//spssle
			//TheDisplay.lcdisplay('setA', scrolltext[scrollpos]);
			//TheDisplay.lcdisplay('setB', scrolltext[scrollpos+1]);
			
			//scrollpos++;
			//if(scrollpos>=scrollcount)scrollpos=0;
			
			
			for (LCD_i = 0; LCD_i < LCDState.length; LCD_i++)
			{
				if (LCDState[LCD_i][0] == LCDMode.BLINK_NONUMBER)
				{
					//showElement(LCD_i, LCD_blinkset == 0 ? 1 : 0);
					TheDisplay.lcdisplay('setItem', LCDState[LCD_i][4], LCD_blinkset == 0 ? false : true);
				}
			}
		}
		else
		{
			
		
		
			if (LCDState[LCD_newIDBlinkNumber][0] == LCDMode.BLINK_NUMBER)
			{
				if (LCD_idBlinkNumber != 255 && LCD_idBlinkNumber != LCD_newIDBlinkNumber)
				{
					if (LCDState[LCD_idBlinkNumber][0] == LCDMode.BLINK_NUMBER)
						//showElement(LCD_idBlinkNumber, lcdElement[LCD_idBlinkNumber].statusFallBack);
						TheDisplay.lcdisplay('setItem', LCDState[LCD_idBlinkNumber][4], LCDState[LCD_idBlinkNumber][6]);
				}
				//showElement(LCD_newIDBlinkNumber, LCD_blinkset == 0 ? 1 : 0);
				TheDisplay.lcdisplay('setItem', LCDState[LCD_newIDBlinkNumber][4], LCD_blinkset == 0 ? false : true);
				if (LCDState[LCD_newIDBlinkNumber][2] != 0 || LCDState[LCD_newIDBlinkNumber][3] != 0)
				{
					//LCDPrintChar0(lcdElement[LCD_newIDBlinkNumber].z1);
					TheDisplay.lcdisplay('setA', LCDState[LCD_newIDBlinkNumber][2]);
					//LCDPrintChar1(lcdElement[LCD_newIDBlinkNumber].z2);
					TheDisplay.lcdisplay('setB', LCDState[LCD_newIDBlinkNumber][3]);
				}
				else
				{
					//LCD_i = sprintf(tnum, "%d", lcdElement[LCD_newIDBlinkNumber].number);
					//c_maxcount = (LCD_i * 2) + 5;

					var tnum = LCDState[LCD_newIDBlinkNumber][1].toString(10);

					c_maxcount = (tnum.length * 2) + 7;
					var tchar;
					var echar='E';
					var tpos;

					if (LCD_cnt < 5)
					{
						tchar = 'R';
					}
					else if(LCD_cnt == c_maxcount-2)
					{
						tchar = ' ';
						echar = ' ';
					}
					else if(LCD_cnt >= c_maxcount-1)
					{
						tchar = ' ';
						echar = ' ';
					}
					else if (LCD_cnt % 2 == 0)
					{
						//tpos= LCD_cnt>3 ? ((LCD_cnt>>2)-2) : 0;
						tpos = LCD_cnt - 2;
						tpos = tpos / 2;
						tpos -= 2;
						tchar = tnum[tpos];
					}
					else
					{
						tchar = ' ';
					}

					TheDisplay.lcdisplay('setA', echar);
					TheDisplay.lcdisplay('setB', tchar);
				}
			}
			else if (LCDState[LCD_newIDBlinkNumber][0] == LCDMode.BLINK_NONUMBER)
			{
				c_maxcount=5;
				TheDisplay.lcdisplay('setItem', LCDState[LCD_newIDBlinkNumber][4], LCD_blinkset == 0 ? false : true);
				TheDisplay.lcdisplay('setA', ' ');
				TheDisplay.lcdisplay('setB', ' ');
			}
			else if (LCDState[LCD_newIDBlinkNumber][0] == LCDMode.LCD_BLINK_NUMBER_EI)
			{
				c_maxcount=5;
				TheDisplay.lcdisplay('setItem', LCDState[LCD_newIDBlinkNumber][4], LCD_blinkset == 0 ? false : true);
				var tnum = LCDState[LCD_newIDBlinkNumber][1].toString(10);
				if(LCDState[LCD_newIDBlinkNumber][1]<10)
				{
					TheDisplay.lcdisplay('setA', '0');
					TheDisplay.lcdisplay('setB', tnum[0]);
				}
				else
				{
					TheDisplay.lcdisplay('setA', tnum[0]);
					TheDisplay.lcdisplay('setB', tnum[1]);
				}
			}
		}

		LCD_cnt++;
		LCD_idBlinkNumber = LCD_newIDBlinkNumber;
		LCD_blinkset = LCD_blinkset == 0 ? 1 : 0;

	};
	
	function lcdtimefunc( )
	{
		if(LCDTimer!=0)window.clearTimeout(LCDTimer);	
		LCDTimer=0;
		ManageLCD();
		LCDTimer=window.setTimeout( function() {lcdtimefunc()},500);
	}


(function($) {

	/*
	$.fn.lcdisplay.defaults = {
		background: 'rgb(230,230,230)',
		inactiveColor: 'rgb(200,200,200)',
		activeColor: 'rgb(10,10,10)',
		width: 300,
		items: false,
		batteryLowColor: false
	};
	*/

	var methods = {
		init: function (options) {
			this.items = options.item || false;
			this.width = options.width || 300;
			this.background = options.background || 'rgb(230,230,230)';
			this.inactiveColor = options.inactiveColor || 'rgb(200,200,200)';
			this.batteryLowColor = options.batteryLowColor || false;
			this.activeColor = options.activeColor || 'rgb(10,10,10)';
			this.layerImage = false;
			
			this._elem = this.get(0);
			var ctx = this._elem.getContext('2d');
			
			this.fontdef= 
[
   0x0000,0xFFFF,0xFFFF,0xFFFF, //
   0xFFFF,0xFFFF,0xFFFF,0xFFFF, //
   0xFFFF,0xFFFF,0xFFFF,0xFFFF, //
   0xFFFF,0xFFFF,0xFFFF,0xFFFF, //
   0x156F,0x1540,0xFFFF,0xFFFF, //  99 +
   0xFFFF,0xFFFF,0xFFFF,0xFFFF, //
   0xFFFF,0xFFFF,0xFFFF,0xFFFF, //
   0xFFFF,0xFFFF,0xFFFF,0xFFFF, //
   0x0000,0x0000,0x0000,0x0000, //
   0x0000,0x0000,0x0000,0x0000, //
   0x0000,0x0000,0x0000,0x0000, //
   0x0000,0x0440,0x0000,0x0000, //
   0x223f,0x0006,0x045b,0x044f, //  0 1 2 3
   0x0466,0x046d,0x047d,0x0007, //  4 5 6 7
   0x047f,0x046f,0x0000,0x0000, //  8 9 : ;
   0x0000,0x0000,0x0000,0x0000, //  < = > ?
   0x0000,0x0477,0x150f,0x0039, //  @ A B C
   0x110f,0x0079,0x0071,0x043d, //  D E F G
   0x0476,0x1109,0x001E,0x0a70, //  H I J K
   0x0038,0x02b6,0x08b6,0x003f, //  L M N O
   0x0473,0x083f,0x0C73,0x046d, //  P Q R S
   0x1101,0x003e,0x2230,0x2836, //  T U V W
   0x2a80,0x1280,0x2209,0x0000, //  X Y Z |
   0x0000,0x0000,0x0000,0x0000 //  ~
];
			
			if(ctx) {
				var objImg = new Image();
				var displaySrc = "img?i=images/lcd_display_600.png";
				
				if( this.width <= 100 ) {
					var displaySrc = "img?i=images/lcd_display_100b.png";
				} else if( this.width <= 200 ) {
					var displaySrc = "img?i=images/lcd_display_200.png";
				} else if( this.width <= 300 ) {
					var displaySrc = "img?i=images/lcd_display_300.png";
				}
				
				objImg.src = displaySrc;
				
				// save image in cache-var
				this.layerImage = objImg;
				var parent = this;
				
				// draw first lcd-canvas, if image is ready
				objImg.onload = function(){
					parent.draw(ctx, objImg);
				}
				
			}
			
			return this;
		},
		setItem: function(item, value) {
			// set new var
			this.items[item] = value;
			
			// then re-draw canvas
			var ctx = this._elem.getContext('2d');
			if(ctx) {
				ctx.clearRect(0,0,this.width, this.width*0.6);
				this.draw(ctx, this.layerImage);
			}
			
			return this;
		},
		getItem: function(item) {
			// just return the vakue
			return  this.items[item];
		},
		setA: function(character)
		{
			var ctp=character.charCodeAt(0);

			this.items.aa=((this.fontdef[ctp]&0x0001)!=0)?true:false;
			this.items.ab=((this.fontdef[ctp]&0x0002)!=0)?true:false;
			this.items.ac=((this.fontdef[ctp]&0x0004)!=0)?true:false;
			this.items.ad=((this.fontdef[ctp]&0x0008)!=0)?true:false;
			this.items.ae=((this.fontdef[ctp]&0x0010)!=0)?true:false;
			this.items.af=((this.fontdef[ctp]&0x0020)!=0)?true:false;
			this.items.ag=((this.fontdef[ctp]&0x0040)!=0)?true:false;
			this.items.ah=((this.fontdef[ctp]&0x0080)!=0)?true:false;
			this.items.ai=((this.fontdef[ctp]&0x0100)!=0)?true:false;
			this.items.aj=((this.fontdef[ctp]&0x0200)!=0)?true:false;
			this.items.ak=((this.fontdef[ctp]&0x0400)!=0)?true:false;
			this.items.al=((this.fontdef[ctp]&0x0800)!=0)?true:false;
			this.items.am=((this.fontdef[ctp]&0x1000)!=0)?true:false;
			this.items.an=((this.fontdef[ctp]&0x2000)!=0)?true:false;
		},
		setB: function(character)
		{
			var ctp=character.charCodeAt(0);

			this.items.ba=((this.fontdef[ctp]&0x0001)!=0)?true:false;
			this.items.bb=((this.fontdef[ctp]&0x0002)!=0)?true:false;
			this.items.bc=((this.fontdef[ctp]&0x0004)!=0)?true:false;
			this.items.bd=((this.fontdef[ctp]&0x0008)!=0)?true:false;
			this.items.be=((this.fontdef[ctp]&0x0010)!=0)?true:false;
			this.items.bf=((this.fontdef[ctp]&0x0020)!=0)?true:false;
			this.items.bg=((this.fontdef[ctp]&0x0040)!=0)?true:false;
			this.items.bh=((this.fontdef[ctp]&0x0080)!=0)?true:false;
			this.items.bi=((this.fontdef[ctp]&0x0100)!=0)?true:false;
			this.items.bj=((this.fontdef[ctp]&0x0200)!=0)?true:false;
			this.items.bk=((this.fontdef[ctp]&0x0400)!=0)?true:false;
			this.items.bl=((this.fontdef[ctp]&0x0800)!=0)?true:false;
			this.items.bm=((this.fontdef[ctp]&0x1000)!=0)?true:false;
			this.items.bn=((this.fontdef[ctp]&0x2000)!=0)?true:false;
		}
	};

	$.fn.lcdisplay = function(options) {
		if ( methods[options] ) {
			return methods[ options ].apply( this, Array.prototype.slice.call( arguments, 1 ));
		} else if (typeof options === 'object' || !options ) {
			return methods.init.apply( this, arguments );
		} else {
			$.error('Methode ' +  method + ' existiert nicht');
		}
		
		return this.each(function() {
			
		});
	};

		
	$.fn.draw = function(ctx, imageLayer) {
		var activeColor = this.activeColor;
		var inactiveColor = this.inactiveColor;
		var pWidth = this.width;
		var sm = 1/300*pWidth; // Size-multiplicator

		// Hintergrundflche zeichnen
		ctx.beginPath();
		ctx.fillStyle = this.background;
		ctx.fillRect(0, 0, this.width, this.width * 0.6);
		ctx.fill();
		ctx.stroke();
		
		if( this.items ) {
			
			// EASY
			drawItem(this.items.easy, ctx, sm, '', activeColor, inactiveColor, 188, 118, 50, 25);
			
			// GPRS
			drawItem(this.items.gprs, ctx, sm, '', activeColor, inactiveColor, 241, 118, 54, 26);
			
			// WIFI
			drawItem(this.items.wifi, ctx, sm, '', activeColor, inactiveColor, 245, 15, 45, 22);
			
			// T1 - Strom
			drawItem(this.items.t1, ctx, sm, '', activeColor, inactiveColor, 7, 10, 45, 44);
			
			// T2 - Kugel
			drawItem(this.items.t2, ctx, sm, '', activeColor, inactiveColor, 7, 62, 46, 46);
			
			// T3 - %
			drawItem(this.items.t3, ctx, sm, '', activeColor, inactiveColor, 7, 126, 46, 46);
			
			
			
			// T4 - Windrad
			ctx.beginPath();
			ctx.moveTo(65*sm, 126*sm);
			ctx.lineTo(70*sm, 126*sm);
			ctx.lineTo(97*sm, 146*sm);
			ctx.lineTo(80*sm, 170*sm);
			ctx.lineTo(65*sm, 170*sm);
			ctx.closePath();
			if( this.items.t4 == true ) {
				ctx.fillStyle = activeColor;
			} else {
				ctx.fillStyle = inactiveColor;
			}
			ctx.fill();
			
			//drawItem(this.items.t4, ctx, sm, '', activeColor, inactiveColor, 65, 126, 32, 44);
			
			// T5 - Sonne
			ctx.beginPath();
			ctx.moveTo(89*sm, 122*sm);
			ctx.lineTo(114*sm, 122*sm);
			ctx.lineTo(114*sm, 145*sm);
			ctx.lineTo(102*sm, 145*sm);
			ctx.quadraticCurveTo(89*sm, 140*sm, 89*sm, 122*sm);
			ctx.closePath();
			if( this.items.t5 == true ) {
				ctx.fillStyle = activeColor;
			} else {
				ctx.fillStyle = inactiveColor;
			}
			ctx.fill();
			//drawItem(this.items.t5, ctx, sm, '', activeColor, inactiveColor, 89, 122, 25, 24);
			
			// T6
			ctx.beginPath();
			ctx.moveTo(99*sm, 146*sm);
			ctx.lineTo(120*sm, 146*sm);
			ctx.lineTo(120*sm, 170*sm);
			ctx.lineTo(82*sm, 170*sm);
			ctx.closePath();
			if( this.items.t4 == true ) {
				ctx.fillStyle = activeColor;
			} else {
				ctx.fillStyle = inactiveColor;
			}
			ctx.fill();
			//drawItem(this.items.t6, ctx, sm, '', activeColor, inactiveColor, 84, 146, 33, 24);
			
			// T7 - kWh
			drawItem(this.items.t7, ctx, sm, '', activeColor, inactiveColor, 126, 119, 54, 54);
			
			// T8 - SIM-Karte
			drawItem(this.items.t8, ctx, sm, '', activeColor, inactiveColor, 247, 149, 40, 24);
			
			// T9 - Brief
			drawItem(this.items.t9, ctx, sm, '', activeColor, inactiveColor, 188, 75, 52, 32);
			
			// T10 - Schlssel
			drawItem(this.items.t10, ctx, sm, '', activeColor, inactiveColor, 247, 47, 42, 22);
			
			// T11 - Uhr
			drawItem(this.items.t11, ctx, sm, '', activeColor, inactiveColor, 190, 10, 50, 48);
			
			// T12
			drawItem(this.items.t12, ctx, sm, '', activeColor, inactiveColor, 300, 140, 40, 20);
			

			// AA
			drawItem2(this.items.aa, ctx, sm, '', activeColor, inactiveColor, [[[69 ,12],[121 ,12],[109 ,24],[81 ,24]]]);
			// AB
			drawItem2(this.items.ab, ctx, sm, '', activeColor, inactiveColor, [[[109 ,24],[121 ,12],[120 ,60],[108 ,52]]]);
			// AC
			drawItem2(this.items.ac, ctx, sm, '', activeColor, inactiveColor, [[[119 ,58],[116 ,105],[105 ,94],[105 ,66]]]);
			// AD
			drawItem2(this.items.ad, ctx, sm, '', activeColor, inactiveColor, [[[64 ,104],[115 ,104],[104 ,93],[76 ,93]]]);
			// AE
			drawItem2(this.items.ae, ctx, sm, '', activeColor, inactiveColor, [[[63 ,104],[64 ,57],[78 ,66],[76 ,93]]]);
			// AF
			drawItem2(this.items.af, ctx, sm, '', activeColor, inactiveColor, [[[69 ,12],[80 ,24],[79 ,52],[66 ,58]]]);
			// AG
			drawItem2(this.items.ag, ctx, sm, '', activeColor, inactiveColor, [[[92 ,64],[92 ,53],[78 ,52],[66 ,59],[75 ,64]]]);
			// AH
			drawItem2(this.items.ah, ctx, sm, '', activeColor, inactiveColor, [[[84 ,24],[81 ,24],[80 ,40],[86 ,53],[89 ,53],[89 ,34]]]);
			// AI
			drawItem2(this.items.ai, ctx, sm, '', activeColor, inactiveColor, [[[90 ,25],[89 ,53],[97 ,53],[99 ,25]]]);
			// AJ
			drawItem2(this.items.aj, ctx, sm, '', activeColor, inactiveColor, [[[109 ,25],[105 ,25],[98 ,36],[98 ,53],[101 ,52],[108 ,40]]]);
			// AK
			drawItem2(this.items.ak, ctx, sm, '', activeColor, inactiveColor, [[[92 ,64],[108 ,64],[117 ,59],[108 ,53],[93 ,53]]]);
			// AL
			drawItem2(this.items.al, ctx, sm, '', activeColor, inactiveColor, [[[105 ,93],[105 ,78],[99 ,65],[96 ,65],[96 ,80],[101 ,93]]]);
			// AM
			drawItem2(this.items.am, ctx, sm, '', activeColor, inactiveColor, [[[96 ,65],[87 ,65],[85 ,92],[95 ,92]]]);
			// AN
			drawItem2(this.items.an, ctx, sm, '', activeColor, inactiveColor, [[[86 ,82],[87 ,65],[84 ,65],[77 ,79],[76 ,92],[80 ,92]]]);
		
			// BA
			drawItem2(this.items.ba, ctx, sm, '', activeColor, inactiveColor, [[[69+62 ,12],[121+62 ,12],[109+62 ,24],[81+62 ,24]]]);
			// BB
			drawItem2(this.items.bb, ctx, sm, '', activeColor, inactiveColor, [[[109+62 ,24],[121+62 ,12],[120+62 ,60],[108+62 ,52]]]);
			// BC
			drawItem2(this.items.bc, ctx, sm, '', activeColor, inactiveColor, [[[119+62 ,58],[116+62 ,105],[105+62 ,94],[105+62 ,66]]]);
			// BD
			drawItem2(this.items.bd, ctx, sm, '', activeColor, inactiveColor, [[[64+62 ,104],[115+62 ,104],[104+62 ,93],[76+62 ,93]]]);
			// BE
			drawItem2(this.items.be, ctx, sm, '', activeColor, inactiveColor, [[[63+62 ,104],[64+62 ,57],[78+62 ,66],[76+62 ,93]]]);
			// BF
			drawItem2(this.items.bf, ctx, sm, '', activeColor, inactiveColor, [[[69+62 ,12],[80+62 ,24],[79+62 ,52],[66+62 ,58]]]);
			// BG
			drawItem2(this.items.bg, ctx, sm, '', activeColor, inactiveColor, [[[92+62 ,64],[92+62 ,53],[78+62 ,52],[66+62 ,59],[75+62 ,64]]]);
			// BH
			drawItem2(this.items.bh, ctx, sm, '', activeColor, inactiveColor, [[[84+62 ,24],[81+62 ,24],[80+62 ,40],[86+62 ,53],[89+62 ,53],[89+62 ,34]]]);
			// BI
			drawItem2(this.items.bi, ctx, sm, '', activeColor, inactiveColor, [[[90+62 ,25],[89+62 ,53],[97+62 ,53],[99 +62,25]]]);
			// BJ
			drawItem2(this.items.bj, ctx, sm, '', activeColor, inactiveColor, [[[109+62 ,25],[105+62 ,25],[98+62 ,36],[98+62 ,53],[101 +62,52],[108+62 ,40]]]);
			// BK
			drawItem2(this.items.bk, ctx, sm, '', activeColor, inactiveColor, [[[92+62 ,64],[108 +62,64],[117+62 ,59],[108+62 ,53],[93+62 ,53]]]);
			// BL
			drawItem2(this.items.bl, ctx, sm, '', activeColor, inactiveColor, [[[105 +62,93],[105+62 ,78],[99+62 ,65],[96+62 ,65],[96 +62,80],[101+62 ,93]]]);
			// BM
			drawItem2(this.items.bm, ctx, sm, '', activeColor, inactiveColor, [[[96 +62,65],[87 +62,65],[85+62 ,92],[95+62 ,92]]]);
			// BN
			drawItem2(this.items.bn, ctx, sm, '', activeColor, inactiveColor, [[[86+62 ,82],[87+62 ,65],[84+62 ,65],[77+62 ,79],[76+62 ,92],[80+62 ,92]]]);
		
		
			
			switch(this.items.bat)
			{
				case false:
				case LCDMode.OFF:
				{
					this.items.bat1=false;
					this.items.bat2=false;
					this.items.bat3=false;
					this.items.bat4=false;
					break;
				}
				case LCDMode.ON0:
				{
					this.items.bat1=false;
					this.items.bat2=false;
					this.items.bat3=false;
					this.items.bat4=true;
					break;
				}
				case LCDMode.ON1:
				{
					this.items.bat1=true;
					this.items.bat2=false;
					this.items.bat3=false;
					this.items.bat4=true;
					break;
				}
				case LCDMode.ON2:
				{
					this.items.bat1=true;
					this.items.bat2=true;
					this.items.bat3=false;
					this.items.bat4=true;
					break;
				}
				case true:
				case LCDMode.ON3:
				{
					this.items.bat1=true;
					this.items.bat2=true;
					this.items.bat3=true;
					this.items.bat4=true;
					break;
				}
				case LCDMode.RUNSTATE3:
				{
					this.items.bat1=true;
					this.items.bat2=true;
					this.items.bat3=true;
					this.items.bat4=false;
					break;
				}
			}
			drawItem2(this.items.bat4, ctx, sm, '', activeColor, inactiveColor, [[[236 ,162],[234 ,162],[234 ,168],[ 196,168],[196 ,152],[234 ,152],[134 ,158],[236 ,158],[236 ,150],[192 ,150],[192 ,170],[236 ,170]]]);
			drawItem2(this.items.bat1, ctx, sm, '', activeColor, inactiveColor, [[[197 ,153],[208 ,153],[208 ,167],[ 197,167]]]);
			drawItem2(this.items.bat2, ctx, sm, '', activeColor, inactiveColor, [[[209 ,153],[221 ,153],[221 ,167],[ 209,167]]]);
			drawItem2(this.items.bat3, ctx, sm, '', activeColor, inactiveColor, [[[222 ,153],[233 ,153],[233 ,167],[ 222,167]]]);

			
			switch(this.items.sig)
			{
				case false:
				case LCDMode.ON0:
				case LCDMode.OFF:
				{
					this.items.l1=false;
					this.items.l2=false;
					this.items.l3=false;
					this.items.l4=false;
					this.items.l5=false;
					break;
				}
				case LCDMode.ON1:
				{
					this.items.l1=true;
					this.items.l2=false;
					this.items.l3=false;
					this.items.l4=false;
					this.items.l5=false;
					break;
				}
				case LCDMode.ON2:
				{
					this.items.l1=true;
					this.items.l2=true;
					this.items.l3=false;
					this.items.l4=false;
					this.items.l5=false;
					break;
				}
				case LCDMode.ON3:
				{
					this.items.l1=true;
					this.items.l2=true;
					this.items.l3=true;
					this.items.l4=false;
					this.items.l5=false;
					break;
				}
				case LCDMode.ON4:
				{
					this.items.l1=true;
					this.items.l2=true;
					this.items.l3=true;
					this.items.l4=true;
					this.items.l5=false;
					break;
				}
				case true:
				case LCDMode.ON5:
				{
					this.items.l1=true;
					this.items.l2=true;
					this.items.l3=true;
					this.items.l4=true;
					this.items.l5=true;
					break;
				}
			}
			
			drawItem2(this.items.l1, ctx, sm, '', activeColor, inactiveColor, [[[250 ,95],[256 ,95],[256 ,104],[250 ,104]]]);
			drawItem2(this.items.l2, ctx, sm, '', activeColor, inactiveColor, [[[256 ,90],[263 ,90],[263 ,104],[256 ,104]]]);
			drawItem2(this.items.l3, ctx, sm, '', activeColor, inactiveColor, [[[263 ,84],[269 ,84],[269 ,104],[263 ,104]]]);
			drawItem2(this.items.l4, ctx, sm, '', activeColor, inactiveColor, [[[269 ,79],[276 ,79],[276 ,104],[269 ,104]]]);
			drawItem2(this.items.l5, ctx, sm, '', activeColor, inactiveColor, [[[276 ,74],[283 ,74],[283 ,104],[276 ,104]]]);
			
			
			
			
			/*
			if( this.items.l && this.items.l >= 0 && this.items.l < 6 ) {
				var startXpos = 255, startYpos = 110, barHeight = 7, barWidth = 6;
				for(var i = 0; i < 5; i++) {
					ctx.beginPath();
					if( i < this.items.l ) {
						ctx.fillStyle = activeColor;
					} else {
						ctx.fillStyle = inactiveColor;
					}
					ctx.fillRect(startXpos*sm, Math.floor(startYpos*sm), barWidth*sm, Math.floor(-barHeight*sm));
					ctx.fill();
					//ctx.stroke();
					
					barHeight = barHeight+5;
					startXpos = startXpos+7;
				}
			}			*/
			
			/*if( this.items.bat && this.items.bat >= 0 && this.items.bat < 5 ) {
				// draw background
				var batBgColor = inactiveColor;
				if( this.items.bat <= 1 && this.batteryLowColor ) {
					batBgColor = this.batteryLowColor;
				}
				drawItem(false, ctx, sm, '', activeColor, batBgColor, 188, 147, 54, 27);
				
				if( this.items.bat == 4 ) {
					drawItem(true, ctx, sm, '', activeColor, inactiveColor, 188, 147, 54, 27);
				} else {
					var batWidth = this.items.bat * 12;
					drawItem(true, ctx, sm, '', activeColor, inactiveColor, 197, 153, batWidth, 14);
				}
			}*/
			
			// draw layer
			if(imageLayer) {
				//ctx.globalAlpha = 0.5;
				ctx.drawImage(imageLayer, 0, 0, pWidth, pWidth * 0.6);
				//ctx.globalAlpha = 1;
			}
			
			// draw over the layer
			// L - Verbindungsstrke
			
		}

		this.ctx = ctx;
		
		return this;
	};
	
	function drawItem(val, ctx, sm, src, act, inact, x, y, w, h) {
		if( typeof(val) != "undefined" && val != "disabled" ) {
			ctx.beginPath();
			if( val == true ) {
				ctx.fillStyle = act;
			} else {
				ctx.fillStyle = inact;
			}
			ctx.fillRect((x*sm), (y*sm), (w*sm), (h*sm));
			ctx.fill();
			ctx.stroke();
			
			return true;
		}
		return false;
	}
	
	function drawItem2(val, ctx, sm, src, act, inact, polygons) 
	{
		if( typeof(val) != "undefined" && val != "disabled" )
		{
			for(var cpoly = 0;cpoly!=polygons.length;cpoly++)
			{
				ctx.beginPath();
				if( val == true ) {
					ctx.fillStyle = act;
				} else {
					ctx.fillStyle = inact;
				}

				ctx.moveTo(polygons[cpoly][0][0]*sm,polygons[cpoly][0][1]*sm);
				for(var cvert=0;cvert!=polygons[cpoly].length;cvert++)
				{
					ctx.lineTo(polygons[cpoly][cvert][0]*sm,polygons[cpoly][cvert][1]*sm);
				}
				ctx.closePath();
				
				//ctx.fillRect((x*sm), (y*sm), (w*sm), (h*sm));
				ctx.fill();
				//ctx.stroke();
			}
			return true;
		}
		return false;
	}
	
	
})(jQuery);